#ifndef ARCHPROFILEMANAGER_H
#define ARCHPROFILEMANAGER_H
//
#include <QDialog>
#include <QTreeWidget>
#include <QPushButton>
#include <QMap>
#include "netutils.h"
//
class ArchProfileManager:public QDialog
{
	Q_OBJECT
	
	public:
		//ArchProfileManager(QObject * parent = 0);
		ArchProfileManager();
		QTreeWidget *treeWidget;
		bool profilesWereUpdated;
		bool profileConnectRequested;
		//bool profileDisconnectRequested;
		QString profileDisconnectRequested;
		int profileCurrentId;
		QString profileCurrentName;
		
	private slots:
		void treeItemClicked();
		void treeItemSelectionChanged();
		void profileRename();
		void profileNew();
		void profileEdit();
		void profileCopy();
		void profileDelete();
		void profileConnect();
		void profileDisconnect();
		//void coucou();
	
	private:
		QPushButton *pbConnect;
		QPushButton *pbDisconnect;
		NetUtils *netUtils;
		//QStringList profileGetKeysForProfile(QString);
		QMap<QString, QString> profileGetInfosForProfile(const QString &);
		void profileListUpdate();

	//signals:
	//	void profilesUpdated(); // apparently not used
};
#endif
