/*

[TODO]
- touver un terminal, ou l'emuler
- inclure hwinfo dans le menu system info ?

*/

#include "dialogimpl.h"
#include "texteditor.h"
#include "archprofilemanager.h"
#include "pacmanassistant.h"
#include "systeminfosassistant.h"
#include "netutils.h"
#include "customcommandseditor.h"
#include "networkstopdialog.h"
#include "configurationeditor.h"
#include "archprofilewizard.h"
#include "aboutdialog.h"
//#include "archprofileconnectorthread.h"
#include <QtGui>
#include <QCloseEvent>
#include <QSystemTrayIcon>
#include <QProcess>
#include <QDir>
#include <QFile>
#include <QMap>
#include <QSignalMapper>
#include <QTableWidget>
#include <QDialogButtonBox>
#include <QInputDialog>
#include <QTimer>
#include <QList>
#include <QClipboard>
#include <QFileSystemWatcher>
#include <QDrag>
#include <QMimeData>
//#include <QUrl>
//#include <QNetworkInterface>

#include <iostream>
using namespace std;

//DialogImpl::DialogImpl(QWidget * parent, QString args) : QSystemTrayIcon (parent,args)
DialogImpl::DialogImpl(QObject * parent) : QSystemTrayIcon (parent)
{
	//installEventFilter(this);
	//QDrag *drag = new QDrag();
	//QMimeData *mimeData = new QMimeData;
	//
	//mimeData->setText("toto rules");
	//drag->setMimeData(mimeData);	
	
	matchingEssidIndex = -1;
	
	//ifplugdProcess = new QProcess();
	//ifplugdProcess->setProcessChannelMode(QProcess::MergedChannels);
	//ifplugdProcess->start("ifplugd -n -F -a -q");
	//ifplugdProcess->start("ifplugd -ieth0 -fwI -u0 -d10");
	//ifplugdProcess->start("dmesg");
	
	pacmanProcess = new QProcess();
	networkProfileProcess = new QProcess();
	networkProfileProcess->setProcessChannelMode(QProcess::MergedChannels);
	networkProfileDiscoverProcess = new QProcess();
	busyTimer = new QTimer();
	netUtils = new NetUtils();
	QFileSystemWatcher *profilesWatch = new QFileSystemWatcher();
	profilesWatch->addPath(netUtils->profilesRunningDirName);
	
	busyIndex = 1;
	singleProfileAtOnce = false;
	autoconnectOnStartup = false;
	pacmanProcessRunning = false;
	networkProcessRunning = false;
	networkProfileConnected = false;
	networkProfileSelected = "";
	systrayCurrentIconName = ":/archlogo.png";	
	
	fileSystemActionsList = "systemactions.txt";
	fileSystemFilesList = "systemfiles.txt";
	fileCustomActionsList = "customactions.txt";
	fileStickyClipboardList = "stickyclipboard.txt";
	settingsDir = QString("%1/%2").arg(QDir::homePath()).arg(".archassistant");
	settingsPath = QString("%1/%2").arg(settingsDir).arg("archassistantrc");
	//settingsPath = QString("%1/%2").arg(QDir::homePath()).arg(".archassistant");

	// Generate archassistant settings home dir & files within if applies
	bool homeDirIsOk = false;
	QDir dir(settingsDir);//QDir dir(settingsPath);
	
	if (!dir.exists())
	{
		if ( !dir.mkdir(settingsDir) )
		{
			qDebug() << "Cannot create dir '" << qPrintable(settingsDir) << "'"<< endl;
			showMessage(
				tr("Arch Assistant message"),
				   tr("Cannot create dir '%1'.").arg(settingsDir),
				 QSystemTrayIcon::Warning,
				4000
				);
		}
		else
			homeDirIsOk = true;
	}
	else
		homeDirIsOk = true;

	settingsRead(); // read default values before settings file generation (if applies)

	if (homeDirIsOk)
	{
		if ( !QFile::exists(settingsPath) )
			settingsGenerate();
		if (!QFile::exists(QString("%1/%2").arg(settingsDir).arg(fileSystemActionsList)))
		{
			QFile::copy(
						QString(":/%1").arg(fileSystemActionsList),
						QString("%1/%2").arg(settingsDir).arg(fileSystemActionsList)
						);
		}
		if (!QFile::exists(QString("%1/%2").arg(settingsDir).arg(fileSystemFilesList)))
		{
			QFile::copy(
					QString(":/%1").arg(fileSystemFilesList),
					QString("%1/%2").arg(settingsDir).arg(fileSystemFilesList)
						);
		}
		if (!QFile::exists(QString("%1/%2").arg(settingsDir).arg(fileCustomActionsList)))
		{
			QFile::copy(
						QString(":/%1").arg(fileCustomActionsList),
						QString("%1/%2").arg(settingsDir).arg(fileCustomActionsList)
					   );
		}
			//QFile::copy(
			//			QString(":/%1").arg(filePacmanActionsList),
			//					QString("%1/%2").arg(settingsDir).arg(filePacmanActionsList)
			//		   );
		if (!QFile::exists(QString("%1/%2").arg(settingsDir).arg(fileStickyClipboardList)))
		{
			QFile::copy(
						QString(":/%1").arg(fileStickyClipboardList),
								QString("%1/%2").arg(settingsDir).arg(fileStickyClipboardList)
					   );
		}
	}


	//settingsRead();
	
	initSystray();
	
	//connect(ifplugdProcess, SIGNAL(readyReadStandardOutput()), this, SLOT(ifplugdProcessOutput()));
	
	connect(networkProfileProcess, SIGNAL(readyReadStandardError()), this, SLOT(networkProfileProcessOutput()));
	connect(networkProfileProcess, SIGNAL(finished(int, QProcess::ExitStatus)),this, SLOT(networkProfileProcessEnded(int, QProcess::ExitStatus)));
	connect(networkProfileDiscoverProcess, SIGNAL(finished(int, QProcess::ExitStatus)),this, SLOT(networkProfileProcessDiscoverEnded(int, QProcess::ExitStatus)));
	connect(pacmanProcess, SIGNAL(finished(int, QProcess::ExitStatus)),this, SLOT(pacmanProcessEnded(int, QProcess::ExitStatus)));
	connect(this, SIGNAL(activated(QSystemTrayIcon::ActivationReason)), this, SLOT(systrayActivated(QSystemTrayIcon::ActivationReason)));
	connect(busyTimer, SIGNAL(timeout()), this, SLOT(busyTimerTimeout()));
	//connect(customActionProcess, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(customActionProcessEnded()));
	connect(profilesWatch, SIGNAL(directoryChanged (const QString &)), this, SLOT(networkProfilesCheckActive()));
	
	//if (autoconnectOnStartup == "1" || autoconnectOnStartup.toLower() == "true" || autoconnectOnStartup.toLower() == "yes")
	if (autoconnectOnStartup)
		QTimer::singleShot(500, this, SLOT(networkProfileAutomatic()));//networkProfileAutomatic();
}
/*
bool DialogImpl::eventFilter(QObject *obj, QEvent *event)
{
    if (obj == this) {
    	//qDebug("yo 0");
        //if (event->type() == QEvent::MouseButtonPress)
        	if (event->type() == QEvent::DragEnter)
        {
            //QKeyEvent *keyEvent = static_cast<QKeyEvent*>(event);
            //qDebug() << "Ate key press" << keyEvent->key();
            qDebug("yo 1");
            return true;
        } else {
            return false;
        }
    } else {
    	qDebug("yo 2");
        // pass the event on to the parent class
        return eventFilter(obj, event);
    }
}
*/
void DialogImpl::systrayActivated(QSystemTrayIcon::ActivationReason reason)
{
	switch	( reason )
	{
		case QSystemTrayIcon::DoubleClick:
			networkProfileAutomatic();
			break;
		case QSystemTrayIcon::Trigger:
			//showAbout();
			break;
		case QSystemTrayIcon::MiddleClick:
			networkProfileManage();
			break;
		case QSystemTrayIcon::Context:
			//showAbout();
			break;
		case QSystemTrayIcon::Unknown:
			//showAbout();
			qDebug("banzai");
			break;
	}
}

void DialogImpl::busyTimerTimeout()
{
	//qDebug("busyTimer timeout");
	if (busyIndex == 0)
	{
		setIcon(QIcon(":/archlogo.png"));
		busyIndex ++;
	}
	else
	{
		setIcon(QIcon(":/archlogowait.png"));
		busyIndex --;
	}
}

void DialogImpl::initSystray()
{
	
	//setParent(this);
	
	//setIcon(QIcon(":/archlogo.png"));
	//setToolTip(QString("<P style='white-space:pre; margin: 4px;' align='center' valign='top'><table><tr><td><img src=':/archlogo.png' style='vertical-align: middle;'></td><td valign='middle'>&nbsp;<b>Arch Assistant</b></td></tr><table></P>%1").arg("<P align='center' style='white-space:pre; margin: 4px; text-align: center;'><i>%1<br>%2</i></P>").arg(trUtf8("double-click the icon for automatic connection")).arg(trUtf8("click middle button to show the Profile Manager dialog")));
	
	networkProfilesCheckActive(); // sets up systray icon & main tooltip content
	
	//QAction *actionSystrayTest = new QAction( trUtf8("Test"), this );
	// 	actionSystrayTest->setIcon( QIcon(":/configure.png")  );
	// 	actionSystrayTest->connect( actionSystrayTest, SIGNAL( triggered() ), this, SLOT( pacProcessStart() ) );

	QAction *actionShowAbout = new QAction( trUtf8("About"), this );
	actionShowAbout->setIcon( QIcon(":/arch-logo.png")  );
	actionShowAbout->connect( actionShowAbout, SIGNAL( triggered() ), this, SLOT( showAbout() ) );

	QAction *actionSystraySettings = new QAction( trUtf8("Configure ArchAssistant"), this );
	actionSystraySettings->setIcon( QIcon(":/configure.png")  );
	actionSystraySettings->connect( actionSystraySettings, SIGNAL( triggered() ), this, SLOT( settingsEdit() ) );
	
	QAction *actionSystrayQuit = new QAction( trUtf8("Quit"), this );
	actionSystrayQuit->setIcon( QIcon(":/exit.png")  );
	//actionSystrayQuit->connect( actionSystrayQuit, SIGNAL( triggered() ), this, SLOT( close() ) );
	actionSystrayQuit->connect( actionSystrayQuit, SIGNAL( triggered() ), qApp, SLOT( quit() ) );
	
	QAction *actionDownload = new QAction( trUtf8("Download clipboard's url"), this );
	actionDownload->setIcon( QIcon(":/kget.png")  );
	actionDownload->connect( actionDownload, SIGNAL( triggered() ), this, SLOT( downloadFromClipboard() ) );
	
	QAction *actionLoadEjectTray = new QAction( trUtf8("Load/eject CD-ROM tray"), this );
	actionLoadEjectTray->setIcon( QIcon(":/cdrom_unmount.png")  );
	actionLoadEjectTray->connect( actionLoadEjectTray, SIGNAL( triggered() ), this, SLOT( trayLoadEject() ) );
	//sactionLoadEjectTray->setShortcut(tr("Ctrl+k"));
		
	QAction *actionProfileWizard = new QAction( trUtf8("Instant connection wizard"), this );
	actionProfileWizard->setIcon( QIcon(":/wizard.png")  );
	actionProfileWizard->connect( actionProfileWizard, SIGNAL( triggered() ), this, SLOT( networkProfileWizard() ) );
	
	// --- Setup Network Info Menu ---
	systemInfoMenu = new QMenu();
	systemInfoMenu->setTitle(trUtf8("System Info"));
	systemInfoMenu->setIcon( QIcon(":/theme2_none.png") );
	
	systemInfosListUpdate();

	// --- Setup Custom Actions menu ---
	customActionMenu = new QMenu();
	customActionMenu->setTitle(trUtf8("Custom Actions"));
	customActionMenu->setIcon( QIcon(":/run.png") );
	
	customActionsListUpdate();
	
	// --- Setup System files menu ---
	configFilesMenu = new QMenu();
	configFilesMenu->setTitle(trUtf8("System Files"));
	configFilesMenu->setIcon( QIcon(":/editcopy.xpm") );

	systemFilesListUpdate();
	
	// --- Setup Sticky Clipboard menu ---
	stickyClipboardMenu = new QMenu();
	stickyClipboardMenu->setTitle(trUtf8("Sticky Clipboard"));
	stickyClipboardMenu->setIcon( QIcon(":/klipper_dock.png") );

	stickyClipboardListUpdate();
	
	// --- Setup Network Profiles menu ---
	networkProfilesMenu = new QMenu();
	networkProfilesMenu->setTitle(trUtf8("Network Profiles"));
	networkProfilesMenu->setIcon( QIcon(":/theme0_none.png") );
	
	networkProfilesMenuUpdate();
	
	// --- Setup Pacman Menu ---
	pacmanMenu = new QMenu();
	pacmanMenu->setTitle(trUtf8("Pacman"));
	pacmanMenu->setIcon( QIcon(":/alunn-pacman-24.png") );
	
	/*
	pacmanAction[0] << "-T" << "(-Syu) Pacman Full Upgrade" << "--noclose" << "-e" << "pacman" << "-Syu";
	pacmanAction[1] << "-T" << "(-Su)   Pacman Simple Upgrade" << "--noclose" << "-e" << "pacman" << "-Su";
	pacmanAction[2] << "-T" << "(-Sy)   Pacman Synchronize" << "--noclose" << "-e" << "pacman" << "-Sy";
	pacmanAction[3] << "-T" << "(-Scc) Pacman Empty Cache" << "--noclose" << "-e" << "pacman" << "-Scc";
	pacmanAction[4] << "request" << "-T" << "(-S)     Pacman Install package(s)" << "--noclose" << "-e" << "pacman" << "-S";
	pacmanAction[5] << "request" << "-T" << "(-R)     Pacman Remove package(s)" << "--noclose" << "-e" << "pacman" << "-R";
	pacmanAction[6] << "request" << "-T" << "(-Ss)   Pacman Search package" << "--noclose" << "-e" << "pacman" << "-Ss";
	pacmanAction[7] << "request" << "-T" << "(-Si)    Pacman Get Info for package" << "--noclose" << "-e" << "pacman" << "-Si";
	pacmanAction[8] << "request" << "-T" << "(-Ql)    Pacman Show Files in package" << "--noclose" << "-e" << "pacman" << "-Ql";
	*/
	pacmanAction[0] << "-T" << trUtf8("(-Syu) Pacman Full Upgrade") << "--noclose" << "-e" << pacmanBin << "--noprogressbar -Syu";
	pacmanAction[1] << "-T" << trUtf8("(-Su)   Pacman Simple Upgrade") << "--noclose" << "-e" << pacmanBin << "--noprogressbar -Su";
	pacmanAction[2] << "-T" << trUtf8("(-Sy)   Pacman Synchronize") << "--noclose" << "-e" << pacmanBin << "--noprogressbar -Sy";
	pacmanAction[3] << "-T" << trUtf8("(-Scc) Pacman Empty Cache") << "--noclose" << "-e" << pacmanBin << "-Scc";
	pacmanAction[4] << "request" << "-T" << trUtf8("(-S)     Pacman Install package(s)") << "--noclose" << "-e" << pacmanBin << "--noprogressbar -S";
	pacmanAction[5] << "request" << "-T" << trUtf8("(-R)     Pacman Remove package(s)") << "--noclose" << "-e" << pacmanBin << "-R";
	pacmanAction[6] << "request" << "-T" << trUtf8("(-Ss)   Pacman Search package") << "--noclose" << "-e" << pacmanBin << "-Ss";
	pacmanAction[7] << "request" << "-T" << trUtf8("(-Si)    Pacman Get Info for package") << "--noclose" << "-e" << pacmanBin << "-Si";
	pacmanAction[8] << "request" << "-T" << trUtf8("(-Ql)    Pacman Show Files in package") << "--noclose" << "-e" << pacmanBin << "-Ql";

	//pacmanAction = readActionsList(filePacmanActionsList);
	
	QSignalMapper *signalMapperFour = new QSignalMapper(this);
	signalMapperFour->connect(signalMapperFour, SIGNAL(mapped(int)), this, SLOT(pacmanActionClicked(int)));
	
	int descrIdx;
	
	for (int i = 0; i < 9; ++i)
	{
		if (pacmanAction[i].at(0) == "request")
			descrIdx = 2;
		else
			descrIdx = 1;
		QAction * actionT = new QAction( pacmanAction[i].at(descrIdx), this );
		signalMapperFour->setMapping(actionT, i);
		actionT->connect( actionT, SIGNAL( triggered() ), signalMapperFour, SLOT( map() ) );
		actionT->setIcon(QIcon(":/theme1_none.png"));
		
		if (i<6)
			actionT->setDisabled(true);
		
		pacmanMenu->addAction(actionT);
	}
	
	systrayMenu = new QMenu("Arch Assistant");
	//systrayMenu->setTitle("Arch Assistant");
	systrayMenu->addMenu(networkProfilesMenu);
	systrayMenu->addMenu(configFilesMenu);
	systrayMenu->addMenu(systemInfoMenu);
	systrayMenu->addMenu(pacmanMenu);
	systrayMenu->addMenu(stickyClipboardMenu);	
	systrayMenu->addMenu(customActionMenu);	
	systrayMenu->addAction(actionProfileWizard);
	systrayMenu->addAction(actionDownload);
	systrayMenu->addAction(actionLoadEjectTray);
	
	systrayMenu->addSeparator();

	systrayMenu->addAction(actionSystraySettings);
	systrayMenu->addAction(actionShowAbout);
	//systrayMenu->addAction(actionSystrayTest);
	systrayMenu->addAction(actionSystrayQuit);

	setContextMenu(systrayMenu);
}

void DialogImpl::showAbout()
{
	AboutDialog *ab = new AboutDialog(0);
	ab->show();
	/*
	return;
	QMessageBox msgBox;
	msgBox.setIconPixmap(QPixmap(":/archlogo.png"));
	//msgBox.setIcon(QMessageBox::Information);
	msgBox.setWindowIcon(QIcon(":/archlogo.png"));
	msgBox.setWindowTitle(tr("About"));
	msgBox.setTextFormat(Qt::RichText);
	msgBox.setText( tr(
						"<b>ArchAssistant</b> v0.4<br>"
						"<br>(c) 2008 Thierry Deseez"
						)
				  );
	msgBox.setMinimumWidth(500);
	//msgBox.setStandardButtons(QMessageBox::Yes | QMessageBox::No);
	msgBox.exec();
	//QMessageBox::about( tr("About Arch Assistant"),
		//	tr("<b>ArchAssistant</b> v0.1"));
	*/
}

void DialogImpl::systemFilesListUpdate()
{
	configFilesMenu->clear();
	
	QAction *actionEditSystemFilesList = new QAction( trUtf8("Edit system files list"), this );
	actionEditSystemFilesList->setIcon( QIcon(":/configure.png") );
	actionEditSystemFilesList->connect( actionEditSystemFilesList, SIGNAL( triggered() ), this, SLOT( systemFilesListEdit() ) );
	
	configFilesMenu->addAction(actionEditSystemFilesList);
	configFilesMenu->addSeparator();

	systemFilesName = readActionsList(fileSystemFilesList);
	
	QSignalMapper *signalMapperToo = new QSignalMapper(this);
	signalMapperToo->connect(signalMapperToo, SIGNAL(mapped(int)), this, SLOT(systemFileClicked(int)));

	for (int j = 0; j < systemFilesName.size(); ++j)
	{
		//QAction * actionT = new QAction( systemFilesName.at(j), this );
		QAction * actionT = new QAction( systemFilesName[j].at(1).trimmed(), this );
		signalMapperToo->setMapping(actionT, j);
		actionT->connect( actionT, SIGNAL( triggered() ), signalMapperToo, SLOT( map() ) );
		actionT->setIcon(QIcon(":/filenew.xpm"));
		configFilesMenu->addAction(actionT);
	}
}

void DialogImpl::customActionsListUpdate()
{
	customActionMenu->clear();
	
	QAction *actionEditCustomActions = new QAction( trUtf8("Edit custom actions"), this );
	actionEditCustomActions->setIcon( QIcon(":/configure.png") );
	actionEditCustomActions->connect( actionEditCustomActions, SIGNAL( triggered() ), this, SLOT( customActionsEdit() ) );
	
	customActionMenu->addAction(actionEditCustomActions);
	customActionMenu->addSeparator();

	customActionsName = readActionsList(fileCustomActionsList);

	QSignalMapper *signalMapperTooMuch = new QSignalMapper(this);
	signalMapperTooMuch->connect(signalMapperTooMuch, SIGNAL(mapped(int)), this, SLOT(customActionClicked(int)));

	for (int j = 0; j < customActionsName.size(); ++j)
	{
		//QAction * actionT = new QAction( systemFilesName.at(j), this );
		QAction * actionT = new QAction( customActionsName[j].at(1).trimmed(), this );
		signalMapperTooMuch->setMapping(actionT, j);
		actionT->connect( actionT, SIGNAL( triggered() ), signalMapperTooMuch, SLOT( map() ) );
		actionT->setIcon(QIcon(":/run.png"));
		customActionMenu->addAction(actionT);
	}
}

void DialogImpl::stickyClipboardListUpdate()
{
	stickyClipboardMenu->clear();
	
	QAction *actionEditstickyClipboardList = new QAction( trUtf8("Edit sticky clipboard list"), this );
	actionEditstickyClipboardList->setIcon( QIcon(":/configure.png") );
	actionEditstickyClipboardList->connect( actionEditstickyClipboardList, SIGNAL( triggered() ), this, SLOT( stickyClipboardListEdit() ) );
	
	stickyClipboardMenu->addAction(actionEditstickyClipboardList);
	stickyClipboardMenu->addSeparator();

	stickyClipboardName = readActionsList(fileStickyClipboardList);
	
	QSignalMapper *signalMapperToo = new QSignalMapper(this);
	signalMapperToo->connect(signalMapperToo, SIGNAL(mapped(int)), this, SLOT(stickyClipboardClicked(int)));

	for (int j = 0; j < stickyClipboardName.size(); ++j)
	{
		//QAction * actionT = new QAction( systemFilesName.at(j), this );
		QAction * actionT = new QAction( stickyClipboardName[j].at(0).trimmed(), this );
		signalMapperToo->setMapping(actionT, j);
		actionT->connect( actionT, SIGNAL( triggered() ), signalMapperToo, SLOT( map() ) );
		actionT->setIcon(QIcon(":/klipper_dock.png"));
		stickyClipboardMenu->addAction(actionT);
	}
}

void DialogImpl::systemInfosListUpdate()
{
	systemInfoMenu->clear();
	
	QAction *actionEditSystemInfosList = new QAction( trUtf8("Edit system info list"), this );
	actionEditSystemInfosList->setIcon( QIcon(":/configure.png") );
	actionEditSystemInfosList->connect( actionEditSystemInfosList, SIGNAL( triggered() ), this, SLOT( systemInfosListEdit() ) );
	
	systemInfoMenu->addAction(actionEditSystemInfosList);
	systemInfoMenu->addSeparator();
	
	systemInfoName = readActionsList(fileSystemActionsList);

	QSignalMapper *signalMapperThree = new QSignalMapper(this);
	signalMapperThree->connect(signalMapperThree, SIGNAL(mapped(int)), this, SLOT(systemInfoClicked(int)));

	if (systemInfoName.size() > 0)
	{
		for (int i = 0; i < systemInfoName.size(); ++i) //for (int i = 0; i < 17; ++i)
		{
			QAction * actionT = new QAction( systemInfoName[i].at(1), this );
			signalMapperThree->setMapping(actionT, i);
			actionT->connect( actionT, SIGNAL( triggered() ), signalMapperThree, SLOT( map() ) );
			actionT->setIcon(QIcon(":/run.png"));
			systemInfoMenu->addAction(actionT);
		}
	}
}

void DialogImpl::networkProfilesMenuUpdate()
{
	networkProfilesMenu->clear();
	profileName.clear();

	QAction *actionNetworkProfileStopAll = new QAction( trUtf8("Disconnect network devices"), this );
	actionNetworkProfileStopAll->setIcon( QIcon(":/cr22-action-wired.png") );
	//actionNetworkProfileStopAll->connect( actionNetworkProfileStopAll, SIGNAL( triggered() ), this, SLOT( networkProfileStopAllClicked() ) );
	actionNetworkProfileStopAll->connect( actionNetworkProfileStopAll, SIGNAL( triggered() ), this, SLOT( networkProfileStopAllInterfacesClicked() ) );
	
	QAction *actionNetworkProfileStopAllProfiles = new QAction( trUtf8("Disconnect active profiles"), this );
	actionNetworkProfileStopAllProfiles->setIcon( QIcon(":/cr22-action-wired.png") );
	actionNetworkProfileStopAllProfiles->connect( actionNetworkProfileStopAllProfiles, SIGNAL( triggered() ), this, SLOT( networkProfileStopAllProfilesClicked() ) );
	
	QAction *actionNetworkProfileManage = new QAction( trUtf8("Manage profiles"), this );
	actionNetworkProfileManage->setIcon( QIcon(":/configure.png") );
	actionNetworkProfileManage->connect( actionNetworkProfileManage, SIGNAL( triggered() ), this, SLOT( networkProfileManage() ) );
	
	QAction *actionNetworkProfileAutomatic = new QAction( trUtf8("Automatic connection"), this );
	actionNetworkProfileAutomatic->setIcon( QIcon(":/cr16-app-knetworkmanager.png") );
	actionNetworkProfileAutomatic->connect( actionNetworkProfileAutomatic, SIGNAL( triggered() ), this, SLOT( networkProfileAutomatic() ) );
	
	QAction *actionNetworkProfileWizard = new QAction( trUtf8("Instant connection wizard"), this );
	actionNetworkProfileWizard->setIcon( QIcon(":/wizard.png") );
	actionNetworkProfileWizard->connect( actionNetworkProfileWizard, SIGNAL( triggered() ), this, SLOT( networkProfileWizard() ) );
	
	networkProfilesMenu->addAction(actionNetworkProfileManage);
	networkProfilesMenu->addAction(actionNetworkProfileStopAllProfiles);
	networkProfilesMenu->addAction(actionNetworkProfileStopAll);
	networkProfilesMenu->addAction(actionNetworkProfileAutomatic);
	networkProfilesMenu->addAction(actionNetworkProfileWizard);	
	networkProfilesMenu->addSeparator();
	
	QSignalMapper *signalMapper = new QSignalMapper(this);
	signalMapper->connect(signalMapper, SIGNAL(mapped(int)), this, SLOT(networkProfileClicked(int)));
	
	
	// 	QDir dir("/etc/network-profiles");
	// 	dir.setFilter(QDir::Files);
	// 	QFileInfoList list = dir.entryInfoList();
	QStringList list = netUtils->getListOfProfiles();
	
	for (int i = 0; i < list.size(); ++i)
	{
		//QFileInfo fileInfo = list.at(i);
		profileName << list.at(i);//profileName << fileInfo.fileName();
		
		//if (!fileInfo.fileName().endsWith("~"))
		//{
			//networkProfiles << new QAction( fileInfo.fileName(), this );
			//networkProfiles[i]->connect( networkProfiles[i], SIGNAL( triggered() ), this, SLOT( getNetworkProfiles() ) );
			//networkProfilesMenu->addAction(networkProfiles.at(i));

			//QAction * actionT = new QAction( fileInfo.fileName(), this );
			QAction * actionT = new QAction( list.at(i), this );
			signalMapper->setMapping(actionT, i);
			actionT->connect( actionT, SIGNAL( triggered() ), signalMapper, SLOT( map() ) );
			//actionT->connect( actionT, SIGNAL( triggered() ), this, SLOT( getNetworkProfiles() ) );
			//actionT->setData(fileInfo.fileName());
			if (netUtils->getConnectionForProfile(list.at(i)).toLower()=="wireless")
				actionT->setIcon(QIcon(":/wifi_radar_22x22.png"));
			else
				actionT->setIcon(QIcon(":/cr22-action-nm_device_wired.png"));
			networkProfilesMenu->addAction(actionT);
		//}
	}
}

void DialogImpl::networkProfileClicked(int profileId)
{
	if (networkProcessRunning)
	{
		showMessage(
					tr("Arch Assistant message"),
					tr("Warning : netcfg process already started."),
					QSystemTrayIcon::Warning,
					4000
					);
		return;
	}
	
	// check if profile has already been started
	if (netUtils->getActiveProfilesList().indexOf(profileName.at(profileId)) > -1)
	{
		qDebug("profile already in use.");
		showMessage(
					trUtf8("Arch Assistant message"),
					trUtf8("The profile '%1' is already in use.").arg(profileName.at(profileId)),//trUtf8("The profile you requested is already in use."),
					QSystemTrayIcon::Warning, 7000
				);
		//networkProfileConnected = false;
		//networkProcessRunning = false;
		//busyTimer->stop();
		//setIcon(QIcon(systrayCurrentIconName));//setIcon(QIcon(":/archlogo.png"));
		return;
	}
	
	showMessage(
			tr("Arch Assistant message"),
			tr("Starting network profile '%1' ...").arg(profileName.at(profileId)),
			QSystemTrayIcon::Information,
			3000
			);

	QString str;
	qDebug() << "profile started :" << qPrintable(profileName.at(profileId)) << qPrintable(str.setNum(profileId)) << endl;
	
	// stop all active network devices before starting profile
	if (singleProfileAtOnce)
		bool stopAllNetworkInterfaces = networkProfileStopAll();
	
	/*
	QList<QNetworkInterface> ethList;
	ethList = QNetworkInterface::allInterfaces();
	
	//QString ethStr;
	
	for (int i = 0; i < ethList.size(); ++i)
	{
		//ethStr += ethList.at(i).name();
		//if (ethList.at(i).name() != "lo")
		//{
			//networkProcess->start("netcfg --stop", ethList.at(i).name());
			//if (!networkProcess.waitForStarted())
			//	return;
			//if (!networkProcess.waitForFinished())
			//	return;
		//}	
	}
	*/
	networkProfileSelected = profileName.at(profileId);
	
	//networkProfileProcess->start(QString("netcfg2 ") + profileName.at(profileId));
	networkProfileProcess->start( netUtils->netcfgBinary + " " + profileName.at(profileId));
	
	if (!networkProfileProcess->waitForStarted())
	{
		cout << "error issuing netcfg command." << endl;
		networkProcessRunning = false;
		return;
	}
	
	networkProcessRunning = true;
	//setIcon(QIcon(":/archlogowait.png"));
	if (!busyTimer->isActive())
		busyTimer->start(750);
	
	//QByteArray joe(networkProcess->readAllStandardOutput());
	//joe.append(networkProcess->readLine());
	//joe.replace(QByteArray("'"), QByteArray(""));
    //joe.replace(QByteArray(" "), QByteArray(""));
    //joe.replace(QByteArray("\n"), QByteArray(""));
    //joe.replace(QByteArray("\r"), QByteArray(""));
	//joe = joe;
	
	//QMessageBox msgBox;
	//msgBox.setText(QString::fromStdString ( joe ) );
	//msgBox.setStandardButtons(QMessageBox::Yes | QMessageBox::No);
	//msgBox.exec();
	/*
	char *data = joe.data();
	while (*data)
	{
		cout << "[" << *data << "]" << endl;
		++data;
	 }
 
	showMessage(
				tr("Arch Assistant message"),
				(QString::fromLatin1 ( joe.data() ) ),
				QSystemTrayIcon::Information,
				5000
				);*/
	
}

void DialogImpl::systemFileClicked(int systemFileIndex)
{
	//TextEditor * te = new TextEditor(systemFilesName.at(systemFileIndex));
	TextEditor * te = new TextEditor(systemFilesName[systemFileIndex].at(0).trimmed());
	te->show();
}

void DialogImpl::stickyClipboardClicked(int stickyClipboardIndex)
{
	QClipboard *clipboard = QApplication::clipboard();
	clipboard->setText(stickyClipboardName[stickyClipboardIndex].at(0));
	//QString originalText = clipboard->text();
	
	showMessage(
					tr("Arch Assistant message"),
					tr("'%1' copied to clipboard.")
						.arg(stickyClipboardName[stickyClipboardIndex].at(0)),
					QSystemTrayIcon::Information,
					4000
				   );
}

void DialogImpl::customActionClicked(int customActionIndex)
{
// 	if (customActionProcess->state() == 2)
// 	{
// 		cout << "process already running" << endl;
// 		return;
// 	}
	
	if (customActionsName[customActionIndex].at(0).size() < 2)
	{
		cout << "insufficient parameters to launch valuable process" << endl;
		return;
	}
	
	// Execute requested process
	cout << "launching custom process ..." << endl;
	QProcess *customActionProcess = new QProcess();
	//customActionProcess->setProcessChannelMode(QProcess::MergedChannels);
	customActionProcess->start(customActionsName[customActionIndex].at(0));
	
	if (!customActionProcess->waitForStarted())
	{
		cout << "process could not start" << endl;
		return;
	}
// 	if (!customActionProcess->waitForFinished())
// 	{
// 		cout << "process failed to finish properly" << endl;
// 		return;
// 	}
// 
// 	delete customActionProcess;
}

void DialogImpl::systemInfoClicked(int systemInfoIndex)
{
	SystemInfosAssistant * sia = new SystemInfosAssistant(systemInfoIndex);
	//sia->show();
	sia->exec();
	delete sia;
	//return;
}

void DialogImpl::networkProfileManage()
{
	ArchProfileManager * apm = new ArchProfileManager();
	//connect(apm, SIGNAL(profilesUpdated()), SLOT(networkProfileProcessOutput()));
	//apm->coucou();
	//apm->connect(apm, SIGNAL(profilesUpdated()), this, SLOT(networkProfileProcessOutput()));
	apm->exec();
	
	bool profilesWereUpdated = apm->profilesWereUpdated;
	bool profileConnectRequested = apm->profileConnectRequested;
	const QString profileDisconnectRequested = apm->profileDisconnectRequested;
	//bool profileDisconnectRequested = apm->profileDisconnectRequested;
	//int profileId = apm->treeWidget->currentColumn();
	QString profileText = apm->profileCurrentName;
	//QString profileText = apm->treeWidget->currentItem()->text(0);

	//delete apm;
	
	if (profilesWereUpdated)
		networkProfilesMenuUpdate();

	if (profileConnectRequested)
	{
		int profileId = profileName.indexOf(profileText);
		networkProfileClicked(profileId);
	}
	else if (profileDisconnectRequested.size()>0)//else if (profileDisconnectRequested)
	{
		//int profileId = profileName.indexOf(profileText);
		networkProfileStopOneProfileClicked(profileDisconnectRequested);
	}
}

bool DialogImpl::networkProfileStopAllProfiles()
{
	cout << "Stopping all active profiles ...\t";
	
	QProcess *stopProcess = new QProcess();
	
	stopProcess->start( netUtils->netcfgBinary + " -a");
	
	if (!stopProcess->waitForStarted())
	{
		cout << "[FAILED]" << endl;
		return false;
	}
	if (!stopProcess->waitForFinished())
	{
		cout << "[FAILED]" << endl;
		return false;
	}

	cout << "[DONE]" << endl;
	
	//networkProfileConnected = false;
	//networkProcessRunning = false;
	
	return true;
}

bool DialogImpl::networkProfileStopAllInterfaces()
{
	cout << "Stopping all active network interfaces ...\t";
	
// 	NetworkStopDialog *stopDlg = new NetworkStopDialog(0,0,1);
// 	stopDlg->exec();
// 	
// 	return false;
	
	QStringList ethList = netUtils->getInterfacesList();//QStringList ethList = getInterfacesList();
	QProcess *stopProcess = new QProcess();
	
	for (int i = 0; i < ethList.size(); ++i)
	{
		//ethStr += ethList.at(i);
		stopProcess->start( QString("%1 %2 down").arg(netUtils->ifconfigBinary).arg(ethList.at(i)) );
			
		if (!stopProcess->waitForStarted())
		{
			cout << "[FAILED]" << endl;
			return false;
		}
		if (!stopProcess->waitForFinished())
		{
			cout << "[FAILED]" << endl;
			return false;
		}
	}
	
	cout << "[DONE]" << endl;
	
	//networkProfileConnected = false;
	//networkProcessRunning = false;
	
	return true;
}

bool DialogImpl::networkProfileStopAll()
{
	if (!networkProfileStopAllProfiles())
		return false;
	
	if (!networkProfileStopAllInterfaces())
		return false;
	
	networkProfileConnected = false;
	networkProcessRunning = false;
	
	return true;
}


void DialogImpl::networkProfileStopAllInterfacesClicked()
{
	NetworkStopDialog *stopDlg = new NetworkStopDialog(0,0,1);
	if (stopDlg->exec() == QDialog::Accepted)
	{
		if (stopDlg->errorsCount > 0)
		{
			showMessage(
			tr("Arch Assistant message"),
			tr("Errors occured stopping active network devices."),
			QSystemTrayIcon::Warning,
			4000
			);
		}
		else
		{
			showMessage(
			tr("Arch Assistant message"),
			tr("Network device(s) were successfully disconnected."),
			QSystemTrayIcon::Information,
			4000
			);
		}
	}
}
void DialogImpl::networkProfileStopOneProfileClicked(const QString & profileNameRequested)
{
	NetworkStopDialog *stopDlg = new NetworkStopDialog(0,0,0,profileNameRequested);
	//NetworkStopDialog *stopDlg = new NetworkStopDialog(0,0,0);
	if (stopDlg->exec() == QDialog::Accepted)
	{
		if (stopDlg->errorsCount > 0)
		{
			showMessage(
			tr("Arch Assistant message"),
			tr("Errors occured stopping active profiles."),
			QSystemTrayIcon::Warning,
			4000
			);
		}
		else
		{
			showMessage(
			tr("Arch Assistant message"),
			tr("Profile(s) were successfully disconnected."),
			QSystemTrayIcon::Information,
			4000
			);
		}
	}
}
void DialogImpl::networkProfileStopAllProfilesClicked()
{
	NetworkStopDialog *stopDlg = new NetworkStopDialog(0,0,0);
	//NetworkStopDialog *stopDlg = new NetworkStopDialog(0,0,0);
	if (stopDlg->exec() == QDialog::Accepted)
	{
		if (stopDlg->errorsCount > 0)
		{
			showMessage(
			tr("Arch Assistant message"),
			tr("Errors occured stopping active profiles."),
			QSystemTrayIcon::Warning,
			4000
			);
		}
		else
		{
			showMessage(
			tr("Arch Assistant message"),
			tr("Profile(s) were successfully disconnected."),
			QSystemTrayIcon::Information,
			4000
			);
		}
	}
// 	return;
// 	
// 	QMessageBox msgBox;
// 	msgBox.setWindowTitle(trUtf8("Arch Assistant"));
// 	msgBox.setText(trUtf8("Stop all active profiles ?"));
// 	msgBox.setStandardButtons(QMessageBox::Yes | QMessageBox::No);
// 	
// 	switch (msgBox.exec())
// 	{
// 		case QMessageBox::Yes:
// 			// yes was clicked
// 			break;
// 		case QMessageBox::No:
// 			return;
// 			break;
// 		default:
// 			// should never be reached
// 			break;
// 	}
// 	
// 	if (networkProfileStopAllProfiles())
// 	{
// 		showMessage(
// 					tr("Arch Assistant message"),
// 					tr("All active profiles stopped OK."),
// 					QSystemTrayIcon::Information,
// 					4000
// 				   );
// 	}
// 	else
// 	{
// 		showMessage(
// 					tr("Arch Assistant message"),
// 					tr("Error occured stopping all active profiles."),
// 					QSystemTrayIcon::Warning,
// 					4000
// 				   );
// 	}
}

void DialogImpl::networkProfileStopAllClicked()
{
	QMessageBox msgBox;
	msgBox.setWindowTitle(trUtf8("Arch Assistant"));
	msgBox.setText(trUtf8("Stop all network interfaces ?"));
	msgBox.setStandardButtons(QMessageBox::Yes | QMessageBox::No);
	
	switch (msgBox.exec())
	{
		case QMessageBox::Yes:
			// yes was clicked
			break;
		case QMessageBox::No:
			return;
			break;
		default:
			// should never be reached
			break;
	}
	
	showMessage(
				tr("Arch Assistant message"),
				tr("Stopping all network interfaces ..."),//pacmanRequestAction.join(" "),
				QSystemTrayIcon::Information,
				5000
				);
	
	// Stop network devices
	if ( networkProfileStopAll() )
	{
		showMessage(
			tr("Arch Assistant message"),
			tr("All network interfaces stopped OK."),//pacmanRequestAction.join(" "),
			QSystemTrayIcon::Information,
			4000
			);
	}
	else
	{
		showMessage(
			tr("Arch Assistant message"),
			tr("Error occured stopping all network interfaces."),//pacmanRequestAction.join(" "),
			QSystemTrayIcon::Warning,
			4000
			);
	}
	
	/*
	//QNetworkInterface eth = new QNetworkInterface();
	QList<QNetworkInterface> ethList;
	ethList = QNetworkInterface::allInterfaces();
	
	QString ethStr;
	
	for (int i = 0; i < ethList.size(); ++i)
	{
		ethStr += ethList.at(i).name();
		//if (ethList.at(i).name() != "lo")
		if (ethList.at(i).name().startsWith("eth") || ethList.at(i).name().startsWith("wlan"))
		{
			
			switch (ethList.at(i).flags())
			{
				case QNetworkInterface::IsUp:
					cout << "ethList.at(i).name()" << "is up" << endl;
					break;
				case QNetworkInterface::IsRunning:
					cout << "ethList.at(i).name()" << "is running" << endl;
					break;
				default:
					break;
			}
			
			cout << ethList.at(i).flags() << "is bigup" << endl;
			
			//networkProfileProcess->start(QString("netcfg --stop ") + ethList.at(i).name());
			//if (!networkProfileProcess->waitForStarted())
				//return;
			//if (!networkProfileProcess->waitForFinished())
				//return;
		}
	}
	*/
}

void DialogImpl::networkProfileAutomatic()
{
	// count running interfaces : if multiple possibilities of connection, let the user choose
// 	if (netUtils->getRunningInterfacesCount() > 0)//if (getRunningInterfacesCount() > 0)
// 	{
// 		qDebug("autoconnect : multiple interfaces found.");
// 		showMessage(
// 					trUtf8("Arch Assistant message"),
// 					trUtf8("Multiple network interfaces are available\nfor connection.\nPlease choose appropriate profile."),
// 					QSystemTrayIcon::Information, 7000
// 				   );
// 		return;
// 	}

	// Get list of wireless network's essids available for the wlan interface
	if (wlanDevice.isEmpty())
	{
		qDebug("no wireless interface found.");
		showMessage(
					trUtf8("Arch Assistant message"),
					trUtf8("Warning : no wireless interface found."),
					QSystemTrayIcon::Warning, 4000
					);
		return;
	}
	
	// check whether interface is down or up before launching iwlist
	QString status = netUtils->getInterfaceStatus(wlanDevice);
	qDebug() << "interface " << qPrintable(wlanDevice) << " " << qPrintable(status) << ". Waking up device ..." << endl;
	
	if (status.isEmpty())
	{
		qDebug("netutils -> no wireless interface found.");
		showMessage(
					trUtf8("Arch Assistant message"),
					trUtf8("Warning : no wireless interface found."),
					QSystemTrayIcon::Warning, 4000
				   );
		return;
	}
	
	
	//ArchProfileConnectorThread zeThread = new ArchProfileConnectorThread();
	//zeThread.connectorProcess("jo");
	// 	ArchProfileConnectorThread zeThread;
	// 	zeThread.start();
	// 	zeThread.wait();
	// 	return;
	
	if (status == "down")
	{
		QProcess *ifconfigUpProcess = new QProcess();
		ifconfigUpProcess->start(netUtils->ifconfigBinary + " " + wlanDevice + " up");
	
		if (!ifconfigUpProcess->waitForStarted())
		{
			qDebug("error ifconfigUpProcess");
			return;
		}
		if (!ifconfigUpProcess->waitForFinished())
		{
			qDebug("error ifconfigUpProcess");
			return;
		}
	}
	
	qDebug("Looking for known wireless networks ...");
	showMessage(
				trUtf8("Arch Assistant message"),
				trUtf8("Looking for known wireless networks. Please wait ..."),
				QSystemTrayIcon::Information, 4000
			   );
		
	//QProcess *iwlistProcess = new QProcess();
	networkProfileDiscoverProcess->start(netUtils->iwlistBinary + " " + wlanDevice + " scan");

	if (!networkProfileDiscoverProcess->waitForStarted())
	{
		qDebug("error networkProfileDiscoverProcess");
		return;
	}
	
	//setIcon(QIcon(":/archlogowait.png"));
	if (!busyTimer->isActive())
		busyTimer->start(750);
	
	//return;
	/*
	QProcess *iwlistProcess = new QProcess();
	iwlistProcess->start("iwlist " + wlanDevice + " scan");

	if (!iwlistProcess->waitForStarted())
	{
		qDebug("error iwlistProcess");
		return;
	}
	if (!iwlistProcess->waitForFinished())
	{
		qDebug("error iwlistProcess");
		return;
	}
	
	QTextStream stream(iwlistProcess->readAll().data());
	QString line;
	
	//qDebug() << "essids (iwlist) : ";
	
	do {
		line = stream.readLine().trimmed();
			
		if (line.startsWith("ESSID:"))//if (line.contains("ESSID:"))
		{
			// extract essid name from cell
			QString ssid = line.mid ( line.indexOf ( "\"" ) + 1, line.length() - line.indexOf ( "\"" ) - 2 );
			if ((ssid=="") || (ssid==" "))
				ssid = trUtf8("(hidden cell)");
			
			//qDebug() << qPrintable(ssid) << " / ";
			
			// check for matching ESSID
			if (listOfEssidsInProfiles.indexOf(QRegExp(ssid)) > -1)
			{
				matchingEssidIndex = listOfEssidsInProfiles.indexOf(QRegExp(ssid));
				break;
			}
		}
	} while (!line.isNull());
	
	//qDebug() << endl;

	//launch a 'fake' process to gain time because netcfg2 seems to require a little time after a iwlist scan (problem with DHCP release)
	qDebug() << "sleep start" << endl;
	sleep(2);
	qDebug() << "sleep end" << endl;
	
	if (matchingEssidIndex > -1)
		networkProfileClicked(matchingEssidIndex);
	else
	{
		qDebug("autoconnect : no matching essid found");	
		showMessage(
					trUtf8("Arch Assistant message"),
					trUtf8("Auto Connect : no matching essid found."),
					QSystemTrayIcon::Warning, 4000
					);
	}
	*/
}

void DialogImpl::networkProfileWizard()
{
	ArchProfileWizard * wiz = new ArchProfileWizard();
	wiz->exec();
}

void DialogImpl::pacmanActionClicked(int pacmanActionIndex)
{
	
	if (pacmanProcessRunning)
	{
		showMessage(
					tr("Arch Assistant message"),
					tr("Warning : pacman process already running."),//pacmanRequestAction.join(" "),
					QSystemTrayIcon::Warning, 4000
					);
		return;
	}
	
	/*
	if ( pacmanAction[pacmanActionIndex].at(0) == "request" )
	{
		bool ok;
		QString extraArgs = QInputDialog::getText(0, QString("-- Pacman --"),
                                          QString(pacmanAction[pacmanActionIndex].at(2)),
                                          QLineEdit::Normal,
                                          QString(""),
                                          &ok);
    	if (ok && !extraArgs.isEmpty())
    	{
			QStringList pacmanRequestAction;
			
			QString pacmanRequestActionStr;
			pacmanRequestActionStr = QString("%1 %2 %3")
									.arg(pacmanAction[pacmanActionIndex].at(5))
									.arg(pacmanAction[pacmanActionIndex].at(6))
									.arg(extraArgs);
			
			for (int i = 1; i < pacmanAction[pacmanActionIndex].size(); ++i)
			{
				pacmanRequestAction << pacmanAction[pacmanActionIndex].at(i);
				
			}

			pacmanRequestAction << extraArgs;
			//pacmanProcess->start(shellBin, pacmanRequestAction);
			//PacmanAssistant * pac = new PacmanAssistant(pacmanRequestActionStr);
			
//			PacmanAssistant * pac = new PacmanAssistant(pacmanRequestActionStr, pacmanAction);
			PacmanAssistant * pac = new PacmanAssistant(pacmanActionIndex);
			pac->exec();
			delete pac;
		}
		else
			return;
	}
	else
	{
		QString pacmanRequestActionStr;
		pacmanRequestActionStr = QString("%1 %2")
									.arg(pacmanAction[pacmanActionIndex].at(4))
									.arg(pacmanAction[pacmanActionIndex].at(5));
		//pacmanProcess->start(shellBin, pacmanAction[pacmanActionIndex]);
		//PacmanAssistant * pac = new PacmanAssistant(pacmanRequestActionStr);
		
		//PacmanAssistant * pac = new PacmanAssistant(pacmanRequestActionStr, pacmanAction);
		PacmanAssistant * pac = new PacmanAssistant(pacmanActionIndex);
		pac->exec();
		delete pac;
	}*/
	
	PacmanAssistant * pac = new PacmanAssistant(pacmanActionIndex);
	pac->exec();
	delete pac;
	
	//pacmanProcessRunning = true;
	
	
	
	/*if (pacmanProcessRunning)
	{
		showMessage(
					tr("Arch Assistant message"),
					tr("Warning : pacman process already running."),//pacmanRequestAction.join(" "),
					QSystemTrayIcon::Warning,
					4000
					);
		return;
	}	
	
	if ( pacmanAction[pacmanActionIndex].at(0) == "request" )
	{
		bool ok;
		QString extraargs = QInputDialog::getText(0, QString("-- Pacman --"),
                                          QString(pacmanAction[pacmanActionIndex].at(2)),
                                          QLineEdit::Normal,
                                          QString(""),
                                          &ok);
    	if (ok && !extraargs.isEmpty())
    	{
			QStringList pacmanRequestAction;
			for (int i = 1; i < pacmanAction[pacmanActionIndex].size(); ++i)
			{
				pacmanRequestAction << pacmanAction[pacmanActionIndex].at(i);
			}

			pacmanRequestAction << extraargs;
			pacmanProcess->start(shellBin, pacmanRequestAction);
		}
		else
			return;
	}
	else
	{
		pacmanProcess->start(shellBin, pacmanAction[pacmanActionIndex]);
	}
	
	showMessage(
				tr("Arch Assistant message"),
				tr("Issuing pacman command ..."),//pacmanRequestAction.join(" "),
				QSystemTrayIcon::Information,
				3000
				);
	
	if (!pacmanProcess->waitForStarted())
	{
		cout << "error issuing pacman command." << endl;
		pacmanProcessRunning = false;
		return;
	}
	
	pacmanProcessRunning = true;*/
}

/*
void DialogImpl::ifplugdProcessOutput()
{
	//QByteArray errorBuffer(ifplugdProcess->readAll());
		//QString errorOutput = errorBuffer.trimmed();
//		qDebug() << "Reason :" << qPrintable(errorOutput);
	 while(ifplugdProcess->canReadLine())
        {
			QByteArray buffer(ifplugdProcess->readLine());
			cout << buffer.data() << endl;
	
			showMessage(
				tr("Arch Assistant message"),
				QString(buffer),//pacmanRequestAction.join(" "),
				QSystemTrayIcon::Information,
				4000
						);
	
		
		}
}
*/
void DialogImpl::networkProfileProcessOutput()
{
	 while(networkProfileProcess->canReadLine())
        {
			QByteArray buffer(networkProfileProcess->readLine());
			cout << buffer.data() << endl;
	
			if (buffer.contains("Starting network profile") && buffer.contains("DONE"))
				networkProfileConnected = true;
		/*
			showMessage(
				tr("Arch Assistant message"),
				QString(buffer),//pacmanRequestAction.join(" "),
				QSystemTrayIcon::Information,
				4000
						);
		*/
		
		}
}

void DialogImpl::networkProfileProcessEnded(int exitCode, QProcess::ExitStatus exitStatus)
{
	QString str;
	
	switch (exitStatus)
	{
		case QProcess::NormalExit:
			if (exitCode == 0) // if (networkProfileConnected)
			{
				showMessage(
						tr("Arch Assistant message"),
						tr("Network profile '%1' connected succesfully.")
							.arg(networkProfileSelected),
						QSystemTrayIcon::Information,
						4000
						);
				cout << "Network connected succesfully. ExitCode = " << exitCode << endl;
					//QAction *bof = networkProfilesMenu->actions().at(6);
					//bof->setDisabled(true);
			}
			else
			{
				QByteArray errorBuffer(networkProfileProcess->readAll());
				//QString errorOutput = errorBuffer.mid(errorBuffer.indexOf("]")+1, errorBuffer.indexOf("[",errorBuffer.indexOf("]") ));
				QString errorOutput = errorBuffer.trimmed().mid( errorBuffer.indexOf("]")+2 );
				showMessage(
						tr("Arch Assistant message"),
						tr("Network profile '%1' failed to connect.\n\nREASON :\n%2")
							.arg(networkProfileSelected)
							.arg(errorOutput),
						QSystemTrayIcon::Warning,
						15000
						);
				qDebug() << "Network could not connect ! ExitCode = " << qPrintable(QString::number(exitCode));
				qDebug() << "Reason :" << qPrintable(errorOutput);
			}
			break;
		case QProcess::CrashExit:
			showMessage(
				tr("Arch Assistant message"),
				tr("<b>Error :</b> netcfg command crashed !"),
				QSystemTrayIcon::Information,
				4000
						);
			break;
		default:
			break;
	}
	
	networkProfileConnected = false;
	networkProcessRunning = false;
	busyTimer->stop();
	setIcon(QIcon(systrayCurrentIconName));//setIcon(QIcon(":/archlogo.png"));	
}

void DialogImpl::networkProcessStupidTimerEnded()
{
	if (matchingEssidIndex > -1)
	{
		// check if profile has already been started
		if (netUtils->getActiveProfilesList().indexOf(profileName.at(matchingEssidIndex)) > -1)
		{
			qDebug("autoconnect : profile already in use.");
			showMessage(
						trUtf8("Arch Assistant message"),
							   trUtf8("The profile '%1' is already in use.").arg(profileName.at(matchingEssidIndex)),//trUtf8("The profile you requested is already in use."),
						QSystemTrayIcon::Warning, 7000
					);
			networkProfileConnected = false;
			networkProcessRunning = false;
			busyTimer->stop();
			setIcon(QIcon(systrayCurrentIconName));//setIcon(QIcon(":/archlogo.png"));
			return;
		}
		
		networkProfileClicked(matchingEssidIndex);
	}
	else
	{
		qDebug("autoconnect : no matching essid found");	
		showMessage(
					trUtf8("Arch Assistant message"),
					trUtf8("Auto Connect : no matching essid found."),
					QSystemTrayIcon::Warning, 4000
				   );
	}
}

void DialogImpl::networkProfileProcessDiscoverEnded(int exitCode, QProcess::ExitStatus exitStatus)
{
	QString str;
	matchingEssidIndex = -1;
	QStringList listOfEssidsInProfiles;

	switch (exitStatus)
	{
		case QProcess::NormalExit:
			if (exitCode == 0) // if (networkProfileConnected)
			{
// 				showMessage(
// 						tr("Arch Assistant message"),
// 						tr("Network profile '%1' has been found.").arg(networkProfileSelected),
// 						QSystemTrayIcon::Information,
// 						4000
// 						   );
// 				cout << "Network profile has been found. ExitCode = " << exitCode << endl;
				
				for (int i = 0; i < profileName.size(); ++i)
				{
					//listOfEssidsInProfiles << getEssidForProfile(profileName.at(i));
					listOfEssidsInProfiles << netUtils->getEssidForProfile(profileName.at(i), wlanDevice);
					//qDebug() << qPrintable(getEssidForProfile(profileName.at(i))) << " / ";
				}
				
				QTextStream stream(networkProfileDiscoverProcess->readAll().data());
				QString line;
	
				//qDebug() << "essids (iwlist) : ";
	
				do {
					line = stream.readLine().trimmed();
			
					if (line.startsWith("ESSID:"))//if (line.contains("ESSID:"))
					{
						// extract essid name from cell
						QString ssid = line.mid ( line.indexOf ( "\"" ) + 1, line.length() - line.indexOf ( "\"" ) - 2 );
						if ((ssid=="") || (ssid==" "))
							ssid = trUtf8("(hidden cell)");
			
						//qDebug() << qPrintable(ssid) << " / ";
			
						// check for matching ESSID
						if (listOfEssidsInProfiles.indexOf(QRegExp(ssid)) > -1)
						{
							matchingEssidIndex = listOfEssidsInProfiles.indexOf(QRegExp(ssid));
							break;
						}
					}
				} while (!line.isNull());
	
				//qDebug() << endl;

				//launch a 'fake' process to gain time because netcfg2 seems to require a little time after a iwlist scan (problem with DHCP release)
// 				qDebug() << "sleep start" << endl;
// 				sleep(2);
// 				qDebug() << "sleep end" << endl;
				QTimer::singleShot(2000, this, SLOT(networkProcessStupidTimerEnded()));
// 				if (matchingEssidIndex > -1)
// 					networkProfileClicked(matchingEssidIndex);
// 				else
// 				{
// 					qDebug("autoconnect : no matching essid found");	
// 					showMessage(
// 								trUtf8("Arch Assistant message"),
// 								trUtf8("Auto Connect : no matching essid found."),
// 								QSystemTrayIcon::Warning, 4000
// 							   );
// 				}
			}
			else
			{
				showMessage(
							tr("Arch Assistant message"),
							tr("Network profile '%1' failed to connect.")
								.arg(networkProfileSelected),
							QSystemTrayIcon::Warning,
							4000
						   );
				cout << "Network could not connect ! ExitCode = " << exitCode << endl;
			}
			break;
		case QProcess::CrashExit:
			showMessage(
						tr("Arch Assistant message"),
						tr("<b>Error :</b> netcfg command crashed !"),
						QSystemTrayIcon::Information,
						4000
					   );
			break;
		default:
			break;
	}
	
	networkProfileConnected = false;
	networkProcessRunning = false;
	if (matchingEssidIndex == -1)
	{
		if (busyTimer->isActive())
			busyTimer->stop();
		setIcon(QIcon(":/archlogo.png"));
	}
}

void DialogImpl::pacProcessStart()
{
	if (pacmanProcessRunning)
		return;
		
	//PacmanAssistant * pac = new PacmanAssistant(QString("pacman -Syu"));
	
	
	//PacmanAssistant * pac = new PacmanAssistant(QString("pacman -Syu"), pacmanAction);
	
	
	//connect(apm, SIGNAL(profilesUpdated()), SLOT(networkProfileProcessOutput()));
	//apm->coucou();
	//pac->connect(apm, SIGNAL(profilesUpdated()), this, SLOT(networkProfileProcessOutput()));
	//pac->exec();
	//bool profilesWereUpdated = apm->profilesWereUpdated;
	//delete pac;
}

void DialogImpl::pacmanProcessEnded(int exitCode, QProcess::ExitStatus exitStatus)
{
	pacmanProcessRunning = false;
	cout << "pacman process ended succesfully." << endl;
	/*
	showMessage(
				tr("Arch Assistant message"),
				tr("Pacman ended succesfully (%1).").arg(QString(exitCode)),//pacmanRequestAction.join(" "),
				QSystemTrayIcon::Information,
				4000
				);
	*/
}

void DialogImpl::settingsGenerate()
{
	//if ( !QFile::exists( settingsPath ) )
	//{
		QSettings settings(settingsPath, QSettings::IniFormat);
		settings.beginGroup("MAIN");
		//settings.setValue( "pacman", pacmanBin );
		//settings.setValue( "terminal", shellBin );
		settings.setValue( "single_profile_at_once", "no" );
		settings.setValue( "wlan", "" );
		settings.setValue( "autoconnect", QString("no") );
		settings.endGroup();
	//}
}

void DialogImpl::showFileErrorWarning(QString fileName)
{
	QMessageBox::warning(
							0,
							tr("I/O Error"),
							tr("Could not read the following file :\n\n%1").arg(fileName)
							);
}

void DialogImpl::customActionsEdit()
{
	if (!QFile::exists(QString("%1/%2").arg(settingsDir).arg(fileCustomActionsList)))
	{
		showFileErrorWarning(QString("%1/%2").arg(settingsDir).arg(fileCustomActionsList));
		return;
	}
	
	CustomCommandsEditor *customEdit = new CustomCommandsEditor(0,0,QString("%1/%2").arg(settingsDir).arg(fileCustomActionsList), 0);
	if (customEdit->exec() == QDialog::Accepted)
		customActionsListUpdate();
	//TextEditor * te = new TextEditor(QString("%1/%2").arg(settingsDir).arg(fileCustomActionsList));
	//te->show();
}

void DialogImpl::systemInfosListEdit()
{
	if (!QFile::exists(QString("%1/%2").arg(settingsDir).arg(fileSystemActionsList)))
	{
		showFileErrorWarning(QString("%1/%2").arg(settingsDir).arg(fileSystemActionsList));
		return;
	}
	
	CustomCommandsEditor *customEdit = new CustomCommandsEditor(0,0,QString("%1/%2").arg(settingsDir).arg(fileSystemActionsList), 2);
	//customEdit->show();
	if (customEdit->exec() == QDialog::Accepted)
		systemInfosListUpdate();
// 	TextEditor * te = new TextEditor(QString("%1/%2").arg(settingsDir).arg(fileSystemActionsList));
// 	te->show();
}

void DialogImpl::systemFilesListEdit()
{
	if (!QFile::exists(QString("%1/%2").arg(settingsDir).arg(fileSystemFilesList)))
	{
		showFileErrorWarning(QString("%1/%2").arg(settingsDir).arg(fileSystemFilesList));
		return;
	}
	
	CustomCommandsEditor *customEdit = new CustomCommandsEditor(0,0,QString("%1/%2").arg(settingsDir).arg(fileSystemFilesList), 1);
	if (customEdit->exec() == QDialog::Accepted)
		systemFilesListUpdate();
// 	TextEditor * te = new TextEditor(QString("%1/%2").arg(settingsDir).arg(fileSystemFilesList));
// 	te->show();
}

void DialogImpl::stickyClipboardListEdit()
{
	if (!QFile::exists(QString("%1/%2").arg(settingsDir).arg(fileStickyClipboardList)))
	{
		showFileErrorWarning(QString("%1/%2").arg(settingsDir).arg(fileStickyClipboardList));
		return;
	}
	
	CustomCommandsEditor *customEdit = new CustomCommandsEditor(0,0,QString("%1/%2").arg(settingsDir).arg(fileStickyClipboardList), 3);
	if (customEdit->exec() == QDialog::Accepted)
		stickyClipboardListUpdate();
// 	TextEditor * te = new TextEditor(QString("%1/%2").arg(settingsDir).arg(fileSystemFilesList));
// 	te->show();
}

void DialogImpl::settingsEdit()
{
	if ( !QFile::exists( settingsPath ) )
	{
// 		QSettings settings(settingsPath, QSettings::IniFormat);
// 		settings.beginGroup("MAIN");
// 			settings.setValue( "pacman", pacmanBin );
// 			settings.setValue( "terminal", shellBin );
// 			settings.setValue( "wlan", wlanDevice );
// 			settings.setValue( "autoconnect", QString("false") );
// 		settings.endGroup();
		settingsGenerate();
	}
	
	ConfigurationEditor *ce = new ConfigurationEditor(0,0,settingsPath);
	ce->show();
// 	return;
// 	TextEditor * te = new TextEditor(settingsPath);
// 	te->show();
}

void DialogImpl::settingsRead()
{
	QString autoconnectOnStartupTxt;
	QString singleProfileAtOnceTxt;
	QStringList noList;
	QStringList yesList;
	noList << "0" << "no" << "false";
	yesList << "1" << "yes" << "true";
	
	QSettings settings(settingsPath, QSettings::IniFormat);
	settings.beginGroup("MAIN");
		pacmanBin = settings.value("pacman", "pacman").toString();
		shellBin = settings.value("terminal", "konsole").toString();
		autoconnectOnStartupTxt = settings.value("autoconnect", "false").toString();
		wlanDevice = settings.value("wlan", netUtils->getWifiInterfaceName()).toString();
		singleProfileAtOnceTxt = settings.value("single_profile_at_once", "no").toString();
	settings.endGroup();
	
	qDebug() << "wireless device set in config : " << qPrintable(wlanDevice) << endl;
	if (wlanDevice.trimmed().length() < 2)
		wlanDevice = netUtils->getWifiInterfaceName();
	else if (netUtils->getInterfacesList().indexOf(wlanDevice.trimmed()) < 0)
		wlanDevice = netUtils->getWifiInterfaceName();
	qDebug() << "wireless device used : " << qPrintable(wlanDevice) << endl;
	
	if ( yesList.indexOf(singleProfileAtOnceTxt.toLower()) > -1 )
		singleProfileAtOnce = true;
	else if ( noList.indexOf(singleProfileAtOnceTxt.toLower()) > -1 )
		singleProfileAtOnce = false;
	
	if ( yesList.indexOf(autoconnectOnStartupTxt.toLower()) > -1 )
		autoconnectOnStartup = true;
	else if ( noList.indexOf(autoconnectOnStartupTxt.toLower()) > -1 )
		autoconnectOnStartup = false;
}

QMap<int, QStringList> DialogImpl::readActionsList(QString fileName)
{
	QMap<int, QStringList> map;
	QString fileNameFound = "";
	//QString settingsPath = QString("%1/%2").arg(QDir::homePath()).arg(".archassistant");

	// guess source file location

	//if ( !QFile::exists( QString("%1/%2").arg(settingsPath).arg(fileName) ) )
	//{
	//	if ( !QFile::copy( QString(":/%1").arg(fileName), QString("%1/%2").arg(settingsPath).arg(fileName) ) )
	//		return map;
	//}
	
	if ( QFile::exists( QString("%1/%2").arg(settingsDir).arg(fileName) ) )
		fileNameFound = QString("%1/%2").arg(settingsDir).arg(fileName);
	else if (QFile::exists( QString(":/%1").arg(fileName) ) )
		fileNameFound = QString(":/%1").arg(fileName);
	else
	{
		showMessage(
					tr("Arch Assistant message"),
					tr("Cannot read file '%1'.").arg(fileName),
					QSystemTrayIcon::Warning,
					4000
					);
		
		return map;
	}
	
	QFile file(fileNameFound);
	if (!file.open(QIODevice::ReadOnly | QIODevice::Text))
		return map;

	int i = 0;

	while (!file.atEnd()) {
		QByteArray line = file.readLine().trimmed();
		if (!line.startsWith("#"))
		{
			map[i] = QString(line).split(";");
			++i;
		}
	}

	return map;
}

void DialogImpl::networkProfilesCheckActive()
{
	QStringList activeProfilesList = netUtils->getActiveProfilesList();
	QString activeProfilesString = QString("<div align='center' style='white-space:pre; margin: 4px; color: blue; font-style: italic;'>%1</div>")
									.arg(trUtf8("no profile connected"));
	QString activeProfilesIconName = "";
	
	if (activeProfilesList.size() > 0)
	{
		activeProfilesString = QString("<P align='left' style='white-space:pre; margin: 4px; text-align: left; color: blue;'><B>%1</B>")
								.arg( trUtf8("Active profile(s) :") );
		
		for (int i = 0; i < activeProfilesList.size(); ++i)
		{
			if ( netUtils->getConnectionForProfile(activeProfilesList.at(i)).toLower() != "wireless" )
				activeProfilesIconName = ":/cr22-action-nm_device_wired.png";
			else
				activeProfilesIconName = ":/wifi_radar_22x22.png";
					
			activeProfilesString.append(
					QString("<br>&nbsp;&nbsp;<img src='%1' style='vertical-align: middle;'> %2")
					.arg( activeProfilesIconName )
					.arg( activeProfilesList.at(i) )
					);
		}
		
		activeProfilesString.append("</P>");		
		systrayCurrentIconName = ":/archlogoconnected.png";
		
	}
	else
	{
		systrayCurrentIconName = ":/archlogo.png";
	}
	
	setIcon(QIcon(systrayCurrentIconName));
	mainToolTipUpdate(activeProfilesString);
	
	/*
	QStringList bambi = netUtils->getListOfProfiles();
	for (int j = 0; j < bambi.size(); ++j)
	{
		if (activeProfilesList.indexOf(bambi.at(j)) > 0 )
		{
			QAction *bof = networkProfilesMenu->actions().at(j);
			bof->setDisabled(true);
		}
		else
		{
			QAction *bof = networkProfilesMenu->actions().at(j);
			bof->setDisabled(false);
		}
	}
	*/
			
}

void DialogImpl::mainToolTipUpdate(const QString & activeProfilesString)
{
	QString tipTitle = "<P style='white-space:pre; margin: 4px;' align='center' valign='top'><table><tr><td><img src=':/archlogo.png' style='vertical-align: middle;'></td><td valign='middle'>&nbsp;<b>Arch Assistant</b></td></tr><table></P>";
	QString tipShortcuts = QString("<P align='center' style='white-space:pre; margin: 4px; text-align: center;'><small><i>%1<br>%2</i></small></P>")
		.arg(trUtf8("double-click the icon for automatic connection"))
		.arg(trUtf8("click middle button to show the Profile Manager dialog"));
	
	setToolTip( QString("%1<BR>%2<BR>%3").arg(tipTitle).arg(activeProfilesString).arg(tipShortcuts) );
}

void DialogImpl::downloadFromClipboard()
{
	/*
	//const QString clipText =  QApplication::clipboard()->text().trimmed();
	//QUrl url("clipText", QUrl::StrictMode);
	QUrl url("&uayiuayzi&éééé");
	
	
	if ( !url.isValid() )
	{
		showMessage(
					tr("Arch Assistant message"),
					tr("Clipboard does not represent a valid URL to be downloaded :\n'%1'.").arg(clipText),
					QSystemTrayIcon::Warning,
					4000
					);
		return;
	}
	*/
	
	// Declare & initialize variables
	QProcess *downloadProcess = new QProcess();
	int itemIndex = 0;
	
	const QString clipText =  QApplication::clipboard()->text().trimmed();
	QStringList itemsList;
	QStringList itemsListDefault;
	QString itemsListStr;

	//QString downloaderApp = "kget";
	itemsListDefault << "kget" << "qbittorrent" << "ktorrent" << "aria2c" << "gwget" << "deluge" << "transmission" << "azureus";
		
	// Reading applications list from config file
	QSettings settings(settingsPath, QSettings::IniFormat);
	settings.beginGroup("MAIN");
		itemsListStr = settings.value("downloader_apps", "").toString();
		if (itemsListStr.isEmpty())
		{
			itemsList << itemsListDefault;
			settings.setValue("downloader_apps", itemsListDefault.join(","));
		}
		else
			itemsList = itemsListStr.split(",", QString::SkipEmptyParts);
	settings.endGroup();
	
	// Autoselect appropriate app from clipboard's content extension
	if (clipText.endsWith(".torrent"))
		itemIndex = 1;//downloaderApp = "qbittorrent";
	
	// Show application selector dialog
	bool ok;
	QString itemSelected = QInputDialog::getItem
	(
		0, tr("Choose Downloader Application"),
		QString("%1 :<br><span style='color: blue; font-style: italic;'>%2</span><br>")
			.arg(trUtf8("Choose application to download following url"))
			.arg(clipText),
		itemsList,
		itemIndex,
		false,
		&ok
	);
	
	// Launch external process if necessary
	if (ok && !itemSelected.isEmpty())
		downloadProcess->startDetached( QString("%1 %2").arg(itemSelected).arg(clipText) );

	//downloadProcess->startDetached( QString("%1 %2").arg(downloaderApp).arg(clipText) );
}

void DialogImpl::trayLoadEject()
{
	QProcess *trayProcess = new QProcess();
	trayProcess->startDetached("eject -T cdrom");	
	showMessage(
			tr("Arch Assistant message"),
			tr("Loading/ejecting CD-ROM tray..."),
			QSystemTrayIcon::Information,
			4000
			);
}
//
